<!--
  ~ #%L
  ~ chvote-bo
  ~ %%
  ~ Copyright (C) 2016 - 2019 République et Canton de Genève
  ~ %%
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  ~ GNU General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  ~ #L%
  -->

<mat-card id="registerUpload">
  <mat-card-header>
    <mat-card-title>{{ "voting-material.register.title" | translate }}</mat-card-title>
    <mat-card-subtitle>{{ "voting-material.register.upload.subtitle" | translate:operation }}</mat-card-subtitle>
  </mat-card-header>
  <mat-card-content fxLayout="column" class="no-padding">

    <div class="mat-card-button-toolbar">
      <upload-input [uploadUrl]="uploadUrl"
                    fileAccept=".xml"
                    uploadIcon="search"
                    uploadText="voting-material.register.upload.actions.preview"
                    progressText="global.upload-progress"
                    (uploadStarted)="resetResult()"
                    (uploadDone)="setResult($event)">
      </upload-input>

      <div
        *ngIf="result && (result.validationErrors.length > 0 || result.duplicates.length > 0 || result.undefinedDois.length > 0)">
        <div class="error-title" fxLayout fxLayoutGap="1rem">
          <mat-icon>warning</mat-icon>
          <span fxFlexAlign="center">{{ 'voting-material.register.upload.errors.title' | translate:result }}</span>
        </div>

        <div *ngIf="result && result.validationErrors.length > 0" id="validationErrors">
          <mat-divider></mat-divider>
          <div fxLayout fxLayoutGap="2.5rem" class="upload-error">
            <mat-icon fxFlexAlign="center" class="error-icon">playlist_add_check</mat-icon>
            <div fxLayout="column" fxLayoutGap="0.5rem" fxFlex="1 1 auto">
              <span>{{ "voting-material.register.upload.errors.schema-validation.line1" | translate }}</span>
              <span>{{ "voting-material.register.upload.errors.schema-validation.line2" | translate }}</span>
            </div>
            <button mat-button color="primary"
                    id="validationErrorsDownloadButton"
                    fxFlexAlign="center"
                    fxFlex="0 0 34rem"
                    (click)="downloadValidationReport()">
              <mat-icon>file_download</mat-icon>&nbsp;{{ "global.actions.error-report-download" | translate | uppercase }}
            </button>
          </div>
        </div>

        <div *ngIf="result && result.duplicates.length > 0" id="duplicateErrors">
          <mat-divider></mat-divider>
          <div fxLayout fxLayoutGap="2.5rem" class="upload-error">
            <mat-icon fxFlexAlign="center" class="error-icon">group</mat-icon>
            <div fxLayout="column" fxLayoutGap="0.5rem" fxFlex="1 1 auto">
              <span>{{ "voting-material.register.upload.errors.duplicate.line1" | translate }}</span>
              <span>{{ "voting-material.register.upload.errors.duplicate.line2" | translate }}</span>
              <span>{{ "voting-material.register.upload.errors.duplicate.line3" | translate }}</span>
            </div>
            <button mat-button color="primary"
                    id="duplicateErrorsDownloadButton"
                    fxFlexAlign="center"
                    fxFlex="0 0 34rem"
                    (click)="downloadDuplicates()">
              <mat-icon>file_download</mat-icon>&nbsp;{{ "voting-material.register.upload.actions.download-voters" |
              translate | uppercase }}
            </button>
          </div>
        </div>

        <div *ngIf="result && result.undefinedDois.length > 0" id="undefinedDoiErrors">
          <mat-divider></mat-divider>
          <div fxLayout fxLayoutGap="2.5rem" class="upload-error">
            <mat-icon fxFlexAlign="center" class="error-icon">verified_user</mat-icon>
            <div fxLayout="column" fxLayoutGap="0.5rem" fxFlex="1 1 auto">
              <span>{{ "voting-material.register.upload.errors.undefined-doi.line1" | translate }}</span>
              <span>{{ "voting-material.register.upload.errors.undefined-doi.line2" | translate }}</span>
            </div>
            <button mat-button color="primary"
                    id="undefinedDoiErrorsDownloadButton"
                    fxFlexAlign="center"
                    fxFlex="0 0 34rem"
                    (click)="downloadUndefinedDois()">
              <mat-icon>file_download</mat-icon>&nbsp;{{ "voting-material.register.upload.actions.download-voters" |
              translate | uppercase }}
            </button>
          </div>
        </div>
      </div>
    </div>

    <div *ngIf="isValid()" id="registerReport">
      <mat-card-title>{{ 'voting-material.register.upload.upload-valid-title' | translate:operation }}</mat-card-title>
      <mat-table #table [dataSource]="dataSource" matSort id="registerReportTable">
        <ng-container matColumnDef="fileName">
          <mat-header-cell *matHeaderCellDef mat-sort-header> {{"voting-material.register.grid.header.file" |
            translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element"> {{element.fileName}}</mat-cell>
        </ng-container>
        <ng-container matColumnDef="emitter">
          <mat-header-cell *matHeaderCellDef mat-sort-header> {{"voting-material.register.grid.header.emitter" |
            translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element"> {{element.emitter}}</mat-cell>
        </ng-container>
        <ng-container matColumnDef="emissionDate">
          <mat-header-cell *matHeaderCellDef mat-sort-header> {{"voting-material.register.grid.header.emission-date" |
            translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element"> {{element.emissionDate | date:'dd.MM.yyyy'}}</mat-cell>
        </ng-container>
        <ng-container matColumnDef="voterCount">
          <mat-header-cell *matHeaderCellDef mat-sort-header> {{"voting-material.register.grid.header.voter-count" |
            translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element"> {{element.voterCount}}</mat-cell>
        </ng-container>
        <ng-container matColumnDef="doiCount">
          <mat-header-cell *matHeaderCellDef mat-sort-header> {{"voting-material.register.grid.header.doi-count" |
            translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element"> {{element.doiCount}}</mat-cell>
        </ng-container>
        <ng-container matColumnDef="countingCircleCount">
          <mat-header-cell *matHeaderCellDef mat-sort-header>
            {{"voting-material.register.grid.header.counting-circle-count" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element"> {{element.countingCircleCount}}</mat-cell>
        </ng-container>
        <ng-container matColumnDef="detailedReport">
          <mat-header-cell *matHeaderCellDef> {{"voting-material.register.grid.header.detailed-report" | translate}}
          </mat-header-cell>
          <mat-cell *matCellDef="let element">
            <button mat-icon-button
                    color="primary"
                    (click)="getReport()">
              <mat-icon>search</mat-icon>
            </button>
          </mat-cell>
        </ng-container>

        <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
        <mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>
      </mat-table>
    </div>

    <div class="mat-card-button-toolbar"
         fxLayout fxLayoutAlign="end" fxLayoutGap="2.5rem">
      <button mat-button
              id="cancelButton"
              (click)="cancelImport()">
        {{ "global.actions.cancel" | translate | uppercase }}
      </button>
      <button *ngIf="isValid()" mat-raised-button color="primary"
              id="validateImport"
              (click)="importRegister()">
        {{ "global.actions.import" | translate | uppercase }}
      </button>

    </div>

  </mat-card-content>
</mat-card>



